package mx.messaging.messages
{
   public class CommandMessage extends AsyncMessage
   {
      public static const SUBSCRIBE_OPERATION:uint = 0;
      
      public static const UNSUBSCRIBE_OPERATION:uint = 1;
      
      public static const POLL_OPERATION:uint = 2;
      
      public static const CLIENT_SYNC_OPERATION:uint = 4;
      
      public static const CLIENT_PING_OPERATION:uint = 5;
      
      public static const CLUSTER_REQUEST_OPERATION:uint = 7;
      
      public static const LOGIN_OPERATION:uint = 8;
      
      public static const LOGOUT_OPERATION:uint = 9;
      
      public static const SESSION_INVALIDATE_OPERATION:uint = 10;
      
      public static const UNKNOWN_OPERATION:uint = 10000;
      
      public static const AUTHENTICATION_MESSAGE_REF_TYPE:String = "flex.messaging.messages.AuthenticationMessage";
      
      public static const SELECTOR_HEADER:String = "DSSelector";
      
      private static var operationTexts:Object = null;
      
      public var operation:uint;
      
      public var messageRefType:String;
      
      public function CommandMessage()
      {
         super();
         operation = UNKNOWN_OPERATION;
         messageRefType = null;
      }
      
      public static function getOperationAsString(param1:uint) : String
      {
         var _loc2_:* = undefined;
         if(operationTexts == null)
         {
            operationTexts = {};
            operationTexts[SUBSCRIBE_OPERATION] = "subscribe";
            operationTexts[UNSUBSCRIBE_OPERATION] = "unsubscribe";
            operationTexts[POLL_OPERATION] = "poll";
            operationTexts[CLIENT_SYNC_OPERATION] = "client sync";
            operationTexts[CLIENT_PING_OPERATION] = "client ping";
            operationTexts[CLUSTER_REQUEST_OPERATION] = "cluster request";
            operationTexts[LOGIN_OPERATION] = "login";
            operationTexts[LOGOUT_OPERATION] = "logout";
            operationTexts[SESSION_INVALIDATE_OPERATION] = "session invalidate";
            operationTexts[UNKNOWN_OPERATION] = "unknown";
         }
         _loc2_ = operationTexts[param1];
         return _loc2_ == undefined ? param1.toString() : String(_loc2_);
      }
      
      override public function toString() : String
      {
         return getDebugString();
      }
      
      override protected function addDebugAttributes(param1:Object) : void
      {
         super.addDebugAttributes(param1);
         param1["operation"] = getOperationAsString(operation);
         param1["messageRefType"] = messageRefType;
      }
   }
}

